<?php
/*
Plugin Name: Gaming Delivery Network
Plugin URI: http://www.gamingdeliverynetwork.com/wp
Description: This plugin will add Gaming Delivery Network functionality to your website, including giving you access to add a Contest Wall, or Dynamic Banner to any page or post.
Version: 1.0.0
Author: Gaming Delivery Network
Author URI: http://www.gamingdeliverynetwork.com
License: GPL2
*/

/*  Copyright 2011  Gaming Delivery Network  (email : support@gamingdeliverynetwork.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

function addbuttons() {
// check user permission
if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
return;

// Add only in Rich Editor mode
if ( get_user_option('rich_editing') == 'true') {
add_filter("mce_external_plugins", "plugin_load");
add_filter('mce_buttons', 'register_button');
}
}

function plugin_load($plugin_array) {

	$plug = WP_PLUGIN_URL . '/gaming-delivery-network/editor_plugin.js';
	$plugin_array['GamingDeliveryNetworkButtonSet'] = $plug;
	return $plugin_array;
}

function register_button(&$buttons) {
	$b[] = "GamingDeliveryNetworkButtonWall";
	$b[] = "separator";
	if ( is_array($buttons) && ! empty($buttons) ) {
		$b = array_merge( $b, $buttons );
	}

	return $b;
}

add_action('init', 'addbuttons');


function gamingdeliverynetwork_init()
{
	if (!is_admin()) 
	{
		wp_deregister_script('jquery');
		wp_register_script('jquery', 'https://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js', false, '1.5.1');
		wp_enqueue_script('jquery');

		wp_deregister_script('jqueryuiall');
		wp_register_script('jqueryuiall', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.9/jquery-ui.min.js', false, '1.8.9');
		wp_enqueue_script('jqueryuiall');

		wp_enqueue_script("jquerybdp", 'http://www.gamingdeliverynetwork.com/Scripts/bdp.js', array("jquery","jqueryuiall"), "1.0.0");

		wp_enqueue_script("gdninit", WP_PLUGIN_URL."/gaming-delivery-network/gdninit.js", array("jquery","jqueryuiall", "jquerybdp"), "1.0.0", 1);
	}
}

function gamingdeliverynetwork_apply($content)
{
	$tag = "gdnwallinsert";
	
    // Quickly leave if nothing to replace
    
    if (strpos($content, $tag) == false) { return $content; }

    // Otherwise generate the code and sub it in           
    
    while(strpos($content, $tag) != false) 
    {
		$fulltag = substr($content, strpos($content, $tag) - 12);
		$fulltag = substr($fulltag, 0, strpos($content, "GDN WALL") + 15);
		$params = substr($fulltag, strpos($fulltag, "title=") + 7);
		$params = substr($params, 0, strpos($params, '"'));
		$aparams = explode(",", $params);
		$wallwidth = array_shift($aparams);		
		$wallheight = array_shift($aparams);

		
		$wallcode = "<div id='wall" . mt_rand() . "' class='gdnwall' style='Width:" . $wallwidth . ";Height:" . $wallheight . ";' token='" . get_option('access_token') . "' categories='" . implode(",", $aparams). "'></div>";
		
		
		$content = str_replace_count($fulltag, $wallcode, $content, 1);
	}
   
	return $content;
}

function str_replace_count($search,$replace,$subject,$times) {
    $subject_original=$subject;
    $len=strlen($search);    
    $pos=0;
    for ($i=1;$i<=$times;$i++) {
        $pos=strpos($subject,$search,$pos);
        if($pos!==false) {                
            $subject=substr($subject_original,0,$pos);
            $subject.=$replace;
            $subject.=substr($subject_original,$pos+$len);
            $subject_original=$subject;
        } else {
            break;
        }
    }
    return($subject);
}

add_filter('the_content', 'gamingdeliverynetwork_apply');
add_action('after_setup_theme', 'gamingdeliverynetwork_init');

add_action('admin_menu', 'gamingdeliverynetwork_create_menu');

function gamingdeliverynetwork_create_menu() {

	add_menu_page('Gaming Delivery Network', 'Gaming Delivery Network Settings', 'administrator', __FILE__, 'gamingdeliverynetwork_settings_page',plugins_url('/settings.png', __FILE__));

	add_action( 'admin_init', 'register_gamingdeliverynetworksettings' );
}


function register_gamingdeliverynetworksettings() {
	register_setting( 'gamingdeliverynetwork-settings-group', 'access_token' );
}

function gamingdeliverynetwork_settings_page() {
?>
<div class="wrap">
<h2>Gaming Delivery Network Plugin Settings</h2>

<form method="post" action="options.php">
<?php wp_nonce_field('update-options'); ?>

    <table class="form-table">
	    <tr valign="top">
        <td colspan="2" style="font-size:1.1em;padding:20px;">Please enter your access token (this will typically be your Gaming Delivery Network <b>UserName</b>. If you do not have one please go to <a href="http://www.bestdamnpools.com/signup" target="_blank">www.bestdamnpools.com</a> to create an account.</td>
        </tr>
        
        <tr valign="top">
        <th scope="row">Access Token</th>
        <td><input type="text" name="access_token" value="<?php echo get_option('access_token'); ?>" /></td>
        </tr>
    </table>
    
<input type="hidden" name="action" value="update" />
<input type="hidden" name="page_options" value="access_token" />

<p class="submit">
<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
</p>

</form>
</div>
<?php } ?>